#include <iostream>
#include <fstream>
#include <sys/select.h>

int main_ifs(int argc, char *argv[])
{
  (void)argc;
  char buf[1024];
  std::ifstream ifs(argv[1]);
  ifs.seekg(0, std::ios::end);
  while (!0) {
    struct timeval tv = { 0, 1000000/10 };
    while (!ifs.eof()) {
      std::streamsize size = sizeof(buf);
      ifs.read(buf, size);
      size = ifs.gcount();
      if (size)
	std::cout.write(buf, size);
    }
    if (select(0, NULL, NULL, NULL, &tv) == -1) {}
    ifs.clear();
  }
  return 0;
}
int main_cin(int argc, char *argv[])
{
  (void)argc, (void)argv;
  char buf[64];	// small buffer for binary std::cin of pipe
  std::ios::sync_with_stdio(false);
  std::cin.seekg(0, std::ios::end);
  std::cin.clear();
  while (!0) {
    struct timeval tv = { 0, 1000000/10 };
    while (!std::cin.eof()) {
      std::streamsize size = sizeof(buf);
      std::cin.read(buf, size);
      size = std::cin.gcount();
      if (size)
	std::cout.write(buf, size);
    }
    if (select(0, NULL, NULL, NULL, &tv) == -1) {}
    std::cin.clear();
  }
  return 0;
}
int main(int argc, char *argv[])
{
#if 0
  if (argc > 1)
    return main_ifs(argc, argv);
  return main_cin(argc, argv);
#else
  char buf[1024];
  std::ifstream ifs;
  if (argc > 1) {
    ifs.open(argv[1]);
    std::cin.rdbuf(ifs.rdbuf());
  }
  else
    std::ios::sync_with_stdio(false);
  std::cin.seekg(0, std::ios::end);
  std::cin.clear();
  while (!0) {
    struct timeval tv = { 0, 1000000/10 };
    while (!std::cin.eof()) {
      std::streamsize size = sizeof(buf);
      std::cin.read(buf, size);
      size = std::cin.gcount();
      if (size)
	std::cout.write(buf, size);
    }
    if (select(0, NULL, NULL, NULL, &tv) == -1) {}
    std::cin.clear();
  }
  return 0;
#endif
}
