for d in viewer; do
  (cd "$d" && sh "`basename \"$0\"`" "$@")
done
clean(){
  rm -f autoscan.log stamp-h1 &&
  rm -rf autom4te.cache .deps .libs &&
  rm -f configure.scan config.h config.log config.status Makefile
}
clear(){
  #rm -f AUTHORS COPYING ChangeLog INSTALL NEWS README &&
  rm -f install-sh depcomp missing &&
  rm -f mkinstalldirs &&
  rm -f ltmain.sh libtool &&
  rm -f aclocal.m4 configure.ac* configure config.h.in* Makefile.am Makefile.in &&
  rm -f config.guess config.sub
}
clean
[ "$1" = clean ] && exit 0
clear
[ "$1" = clear ] && exit 0
autoscan -v &&
cat <<'EOF' > "$0.sed"
/^AC_INIT(\[FULL-PACKAGE-NAME\], \[VERSION\], \[BUG-REPORT-ADDRESS\])/{
  s/FULL-PACKAGE-NAME/xclip/; s/VERSION/1.0.0/
  s/, \[BUG-REPORT-ADDRESS\]/, [taiji@aihara.co.jp]/
}
/^AC_INIT(.*)$/{
  a \
AM_INIT_AUTOMAKE(foreign)

}
/^AC_CONFIG_SRCDIR(\[.*\])/s/\[.*\]/[xclip.cc]/
/^AC_PROG_CC/d
/^AC_PROG_INSTALL/{
  a \
AC_PROG_MAKE_SET\
#AC_PROG_LIBTOOL

}
/^AC_PATH_X$/{
  c \
AC_PATH_XTRA\
PKG_CHECK_MODULES([X11], [x11], [X_CFLAGS="$X11_CFLAGS"; X_LIBS="$X11_LIBS"], \
AC_CHECK_LIB([X11], [XOpenDisplay], [X_LIBS="$X_LIBS -lX11"], \
[echo "X11 library is required for $PACKAGE_STRING package"; exit 1], -L${x_libraries}))\
PKG_CHECK_MODULES([XT], [xt], [X_CFLAGS="$XT_CFLAGS"], \
AC_CHECK_LIB([Xt], [XtOpenApplication], [XT_LIBS="-lXt $X_LIBS"], \
[echo "Xt library is required for $PACKAGE_STRING package"; exit 1], -L${x_libraries}))\
PKG_CHECK_MODULES([XMU], [xmu], [X_CFLAGS="$XMU_CFLAGS"], \
AC_CHECK_LIB([Xmu], [XmuInternStrings], [XMU_LIBS="-lXmu $XT_LIBS"], \
[echo "Xmu library is required for $PACKAGE_STRING package"; exit 1], -L${x_libraries}))

}
/^AC_CONFIG_FILES(\[exercises\/makefile\])/d
/^AC_OUTPUT/i \
AC_ARG_ENABLE([i18n], \
[AS_HELP_STRING([--enable-i18n], [i18n feature (default is yes)])], \
[], [enable_i18n=yes]) \
AS_IF([test "x$enable_i18n" != xno], \
[AC_DEFINE([USE_I18N], [1], [Define to 1 if you use i18n feature.])])\
AC_ARG_ENABLE([utf8], \
[AS_HELP_STRING([--enable-utf8], [utf8 feature (default is yes)])], \
[], [enable_utf8=yes])\
AS_IF([test "x$enable_utf8" != xno], \
[AC_DEFINE([USE_UTF8], [1], [Define to 1 if you use utf8 feature.])])\
\
AC_ARG_WITH([xft-prefix], \
[AS_HELP_STRING([[--with-xft-prefix[=prefix]]], [xft prefix (optional)])], \
[xft_prefix=${withval:-/usr/X11R6}], [xft_prefix=no])\
AC_ARG_WITH([cairo-prefix], \
[AS_HELP_STRING([[--with-cairo-prefix[=prefix]]], [cairo prefix (optional)])], \
[cairo_prefix=${withval:-/usr/X11R6}], [cairo_prefix=no])\

/^AC_OUTPUT/i \
AC_CONFIG_FILES([Makefile])

EOF
sed -f "$0.sed" < configure.scan > configure.ac &&
rm -f "$0.sed" &&
cat <<'EOF' > Makefile.am &&
bin_PROGRAMS=xclip
EXTRA_PROGRAMS=xcutbuffer xselection

xcutbuffer_SOURCES=xcutbuffer.cc xcutbuffer.hpp x11_view.hpp geometry.hpp verbose.h deject.h buffer.hpp timeval.hpp
xcutbuffer_CXXFLAGS=-W -Wall -O3 $(X_CFLAGS)
xcutbuffer_LDADD=$(X_LIBS) $(X_EXTRA_LIBS)

xselection_SOURCES=xselection.cc xselection.hpp xt_view.hpp geometry.hpp verbose.h deject.h buffer.hpp text_list.h timeval.hpp
xselection_CXXFLAGS=-W -Wall -O3 $(X_CFLAGS)
xselection_LDADD=$(XMU_LIBS) $(X_EXTRA_LIBS)

xclip_SOURCES=xclip.cc xcutbuffer.hpp xselection.hpp x11_view.hpp xt_view.hpp geometry.hpp verbose.h deject.h buffer.hpp text_list.h timeval.hpp
xclip_CXXFLAGS=-W -Wall -O3 $(X_CFLAGS)
xclip_LDADD=$(XMU_LIBS) $(X_EXTRA_LIBS)

EXTRA_DIST=maintener.sh README.ja.txt \
makefile.osx exercises viewer

SUBDIRS=viewer
EOF
autoreconf -i -f -v
