/*
  timeval.hpp

  Copyright (C) 2012 Taiji Yamada <taiji@aihara.co.jp>
 */
#ifndef _TIMEVAL_HPP_
#define _TIMEVAL_HPP_
#include <sys/time.h>

inline
bool operator<(const struct timeval &a, const struct timeval &b)
{
  if (a.tv_sec < b.tv_sec)
    return true;
  else if (a.tv_sec == b.tv_sec && a.tv_usec < b.tv_usec)
    return true;
  return false;
}
inline
bool operator>(const struct timeval &a, const struct timeval &b)
{
  return b < a;
}
inline
bool operator==(const struct timeval &a, const struct timeval &b)
{
  return !(a < b) && !(b < a);
}
inline
struct timeval operator-(const struct timeval &a, const struct timeval &b)
{
  struct timeval c;
  bool borrow = a.tv_usec < b.tv_usec;
  c.tv_usec = (borrow ? 1000000 : 0) + a.tv_usec - b.tv_usec;
  c.tv_sec = a.tv_sec - b.tv_sec - (borrow ? 1 : 0);
  return c;
}

#endif
