/*
  xcutbufferview.hpp - X cut buffer viewer

  Copyright (C) 2012 Taiji Yamada <taiji@aihara.co.jp>

  This is distributed under the MIT ("X") License.
 */
#if defined(HAVE_CONFIG_H)
#include "config.h"
#endif
#include <iostream>
#include <string>
#include <cstdlib>
#include <cctype>
#include "xcutbuffer.hpp"

bool output_mode = true;
int cutbuffer_index = 0;
int usage(std::ostream &out, const std::string me)
{
  out << "usage: " << me << " [-v] [-c buffer_index] [-i < file]" << std::endl;
  return (out == std::cout) ? 0 : 1;
}
int main(int argc, char *argv[])
{
  int a;
  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argv[0]);
    else if (std::string(argv[a]) == "-v")
      verbose = !0;
    else if (std::string(argv[a]) == "-i")
      output_mode = false;
    else if (std::string(argv[a]) == "-c") {
      cutbuffer_index = 0;
      if (a+1 < argc && (std::isdigit(argv[a+1][0]) ||
                         (argv[a+1][0] == '-' && std::isdigit(argv[a+1][1]))))
        cutbuffer_index = atoi(argv[++a]);
    }

  if (output_mode) {
    xcutbuffer_getter<x11_text_view> v(argc, argv, 640, 480, cutbuffer_index);
    return v.loop();
  }
  xcutbuffer_setter<x11_text_view> v(argc, argv, 640, 480, cutbuffer_index);
  return v.loop();
}
