/*
  xselectionview.cc - X selection viewer

  Copyright (C) 2012 Taiji Yamada <taiji@aihara.co.jp>

  This is distributed under the MIT ("X") License.
 */
#if defined(HAVE_CONFIG_H)
#include "config.h"
#endif
#include <iostream>
#include <string>
#include <cstdlib>
#include <cctype>
#include "xselection.hpp"

bool output_mode = true;
char *selection_name = (char *)"PRIMARY";
int usage(std::ostream &out, const std::string me)
{
  out << "usage: " << me << " [-v] [-s PRIMARY|SECONDARY|CLIPBOARD] [-i < file]" << std::endl;
  return (out == std::cout) ? 0 : 1;
}
int main(int argc, char *argv[])
{
  int a;
  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argv[0]);
    else if (std::string(argv[a]) == "-v")
      verbose = !0;
    else if (std::string(argv[a]) == "-i")
      output_mode = false;
    else if (std::string(argv[a]) == "-s") {
      if (a+1 < argc)
        selection_name = argv[++a];
    }

  if (output_mode) {
    xselection_getter<xt_text_view> v(argc, argv, 640, 480, selection_name);
    return v.loop();
  }
  xselection_setter<xt_text_view> v(argc, argv, 640, 480, selection_name);
  return v.loop();
}
